#!/usr/bin/env python3
import json
import argparse
import os
from pathlib import Path

"""
This creates a models, labels config file and an Exp python file for training yolox on a coco dataset

The COCO Dataset file format is:

coco_root
 ├── annotations
 |   ├── <train_ann_file_name>.json
 |   └── <val_ann_file_name>.json
 └── <dataset directory/ train/val directories> (depends on data path in the annotation files)
 
"""

def make_parser():
    parser = argparse.ArgumentParser("YOLOX train parser")
    # Dataset arguments
    parser.add_argument("-n", "--name", type=str, default=None, help="File name prefixes", required=True)
    parser.add_argument("-r", "--coco_root", type=str, help="coco root path (Parent directory of the annotation and data file )", default=None, required=True)
    parser.add_argument("-ta", "--train_ann", type=str, help="name of the train annotation file", default="default_train.json")
    parser.add_argument("-va", "--val_ann", type=str, help="name of the train annotation file", default="default_val.json")
    parser.add_argument("-pre", "--models_prefix", type=str, help="models prefix", default="object/ycb/",)
    # Model and training arguments (Optional, do not change if you have no idea)
    parser.add_argument("-d", "--depth", type=float, help="Model depth", default=1.33)
    parser.add_argument("-w", "--width", type=float, help="Model width", default=1.25)
    parser.add_argument("-me", "--max_epoch", type=int, help="Maximum number of epochs", default=100)
    parser.add_argument("-nw", "--num_workers", type=int, help="Number of workers", default=4)
    parser.add_argument("-ev", "--eval_interval", type=int, help="Evaluation interval", default=1)
    # Config arguments
    parser.add_argument("-e", "--exp", action='store_false', help="do not create exp if flag is set")
    parser.add_argument("-m", "--models", action='store_false', help="do not create models if flag is set",)
    parser.add_argument("-ys", "--models_save_dir", type=str, help="models prefix", default="config",)
    parser.add_argument("-c", "--checkpoint", type=str, help="Model checkpoint to use", default="models/ycbv-gdrnpp_bop/base_model.pth",)
    return parser

def get_num_classes(annotation_path: str):
    with open(annotation_path, "r") as f:
        return len(json.load(f)["categories"])
    

def create_models(ann_pth: str, name: str, prefix: str, model_save_dir: str):
    models = ""
    with open(ann_pth, "r") as f:
        data = json.load(f)["categories"]
        for x in data:
            models += f'"{x["id"]}": "{prefix}{x["name"]}"\n'
    models_pth = name + "_models.yaml"
    abs_file_path = os.path.join(model_save_dir, models_pth)
    with open(abs_file_path, "w") as f:
        f.write(models)

def create_exp(arguments):
    script = SCRIPT_FILE.format(depth=arguments.depth, width=arguments.width, name=arguments.name, coco_root=arguments.coco_root,
                                train_ann=arguments.train_ann, val_ann=arguments.val_ann, max_epoch=arguments.max_epoch,
                                num_workers=arguments.num_workers, eval_interval=arguments.eval_interval)

    script_dir = os.path.dirname(__file__)
    exp_pth = f"src/yolox_models/exp/{arguments.name}_exp.py"
    abs_file_path = os.path.join(script_dir, exp_pth)
    if os.path.isfile(abs_file_path):
        print("Experiment File already exists! skipping creating new exp.")
    else:
        with open(abs_file_path, "w") as f:
            f.write(script)


SCRIPT_FILE = '''
#!/usr/bin/env python3

# -*- coding:utf-8 -*-
# Copyright (c) Megvii, Inc. and its affiliates.

""" THIS FILE HAS BEEN AUTOGENERATED. DO NOT CHANGE UNLESS YOU KNWO WHAT YOU DO """

import os
import json

from yolox.exp import Exp as MyExp

def get_num_classes(annotation_path: str):
    with open(annotation_path, "r") as f:
        return len(json.load(f)["categories"])


class Exp(MyExp):
    def __init__(self):
        super(Exp, self).__init__()
        self.depth = {depth}
        self.width = {width}
        self.exp_name = "{name}"

        # Define yourself dataset path
        self.data_dir = os.path.expanduser("{coco_root}")
        self.train_name = "/" # name of the training folder
        self.val_name = "/" # name of the validation folder
        self.train_ann = "{train_ann}" # coco training annotations file: '(self.data_dir)/annotations/(self.train_ann)'
        self.val_ann = "{val_ann}" # coco validation annotations file: '(self.data_dir)/annotations/(self.val_ann)'

        self.num_classes = get_num_classes(self.data_dir + "/annotations/" + self.train_ann)

        self.max_epoch = {max_epoch}
        self.data_num_workers = {num_workers}
        self.eval_interval = {eval_interval}

        # Don't spam the hard drive
        self.save_history_ckpt = False


    def get_dataset(self, cache: bool = False, cache_type: str = "ram"):
        """
        Get dataset according to cache and cache_type parameters.
        Args:
            cache (bool): Whether to cache imgs to ram or disk.
            cache_type (str, optional): Defaults to "ram".
                "ram" : Caching imgs to ram for fast training.
                "disk": Caching imgs to disk for fast training.
        """
        from yolox.data import TrainTransform, COCODataset
        # from yolox_models.datasets.gazebo_ycb_nvisii import COCODataset

        return COCODataset(
            data_dir=self.data_dir,
            name=self.train_name,
            json_file=self.train_ann,
            img_size=self.input_size,
            preproc=TrainTransform(
                max_labels=35,
                flip_prob=self.flip_prob,
                hsv_prob=self.hsv_prob
            ),
            cache=cache
        )
    

    def get_data_loader(self, batch_size, is_distributed, no_aug=False, cache_img: str = None):
        """
        Get dataloader according to cache_img parameter.
        Args:
            no_aug (bool, optional): Whether to turn off mosaic data enhancement. Defaults to False.
            cache_img (str, optional): cache_img is equivalent to cache_type. Defaults to None.
                "ram" : Caching imgs to ram for fast training.
                "disk": Caching imgs to disk for fast training.
                None: Do not use cache, in this case cache_data is also None.
        """
        from yolox.data import (
            TrainTransform,
            YoloBatchSampler,
            DataLoader,
            InfiniteSampler,
            MosaicDetection,
            worker_init_reset_seed,
        )
        from yolox.utils import wait_for_the_master

        # if cache is True, we will create self.dataset before launch
        # else we will create self.dataset after launch
        if self.dataset is None:
            with wait_for_the_master():
                assert cache_img is None, \
                    "cache_img must be None if you didn't create self.dataset before launch"
                self.dataset = self.get_dataset(cache=False, cache_type=cache_img)

        self.dataset = MosaicDetection(
            dataset=self.dataset,
            mosaic=not no_aug,
            img_size=self.input_size,
            preproc=TrainTransform(
                max_labels=35,
                flip_prob=self.flip_prob,
                hsv_prob=self.hsv_prob),
            degrees=self.degrees,
            translate=self.translate,
            mosaic_scale=self.mosaic_scale,
            mixup_scale=self.mixup_scale,
            shear=self.shear,
            enable_mixup=self.enable_mixup,
            mosaic_prob=self.mosaic_prob,
            mixup_prob=self.mixup_prob,
        )

        if is_distributed:
            batch_size = batch_size // dist.get_world_size()

        sampler = InfiniteSampler(len(self.dataset), seed=self.seed if self.seed else 0)

        batch_sampler = YoloBatchSampler(
            sampler=sampler,
            batch_size=batch_size,
            drop_last=False,
            mosaic=not no_aug,
        )

        dataloader_kwargs = {{"num_workers": self.data_num_workers, "pin_memory": True}}
        dataloader_kwargs["batch_sampler"] = batch_sampler

        # Make sure each process has different random seed, especially for 'fork' method.
        # Check https://github.com/pytorch/pytorch/issues/63311 for more details.
        dataloader_kwargs["worker_init_fn"] = worker_init_reset_seed

        train_loader = DataLoader(self.dataset, **dataloader_kwargs)

        return train_loader
    
    def get_eval_dataset(self, **kwargs):
        from yolox.data import COCODataset, ValTransform
        testdev = kwargs.get("testdev", False)
        legacy = kwargs.get("legacy", False)

        return COCODataset(
            data_dir=self.data_dir,
            json_file=self.val_ann if not testdev else self.test_ann,
            name=self.val_name,
            img_size=self.test_size,
            preproc=ValTransform(legacy=legacy),
        )

'''


    
if __name__ == "__main__":
    args = make_parser().parse_args()
    if args.models: create_models(args.coco_root + "/annotations/" + args.train_ann, args.name, args.models_prefix, args.models_save_dir)
    if args.exp: create_exp(args)

    script_dir = os.path.dirname(__file__)
    exp_pth = f"src/yolox_models/exp/{args.name}_exp.py"
    abs_file_path = os.path.join(script_dir, exp_pth)
    os.system(f"python -m yolox.tools.train -f {abs_file_path} -b 16 --fp16 -o -c {args.checkpoint}")